<?php

/*
*	heading element
*	version 1.5.0 22/01/2009
*
*	Copyright Ewout Wierda  2008/2009. All rights reserved. 
*	This program is free software: you can redistribute it and/or modify it under 
*	the terms of the GNU General Public License version 3 as published by the 
*	Free Software Foundation, see <http://www.gnu.org/licenses/>.
*	This program is distributed in the hope that it will be useful, but WITHOUT 
*	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*	or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more details.
*	Free for non-commercial use, payment for commercial use on request.
*	mail@joomlaloft.com
*	joomlaloft.com
*
*	This heading element creates a heading parameter type for Joomla xml 
*	installation files. A blue line will appear above the heading with a grey line below. 
*	The 'default' property can be used to set the heading text which will appear 
*	where other parameter types display a form field. The 'label' property can be 
*	used to set the text for a label. The 'description' property can be used to set 
*	the text of a tooltip for the label. If capitals are used for these properties then 
*	the actual text can be put in language files. Example for use: in the xml 
*	installation file: <param name="general" type="heading" 
*	default="HEADING_GENERAL" label="HEADING_LABEL" 
*	description="HEADING_HELP_GENERAL" />; and in the language file: 
*	HEADING_GENERAL=General settings HEADING_LABEL=[?] 
*	HEADING_HELP_GENERAL=These are general settings.
*	This heading element is based on Joomla elements. 
*
*/

defined('JPATH_BASE') or die();

/**
 * Renders a heading element
 */

class JElementHeading extends JElement
{
	var	$_name = 'Heading';

	function fetchTooltip($label, $description, &$node, $control_name, $name) {
		$output = '<br/>';
		$output .= '<hr color="#4B88E4" style="color:#4B88E4; margin-top:7px; margin-bottom:7px;"/>';
		$output .= '<label id="'.$control_name.$name.'-lbl" for="'.$control_name.$name.'"';
		if ($description) {
			$output .= ' class="hasTip" title="'.JText::_($label).'::'.JText::_($description).'">';
		} else {
			$output .= '>';
		}
		$output .= '<span style="color:#0B55C4; font-weight:normal;">';
		if ($label) {
			$output .= JText::_( $label ).'&nbsp;';
		}
		$output .= '</span></label>';
		$output .= '<hr color="#CCCCCC" style="color:#CCCCCC; margin-top:7px; margin-bottom:7px;"/>';

		return $output;
	}

	function fetchElement($name, $value, &$node, $control_name)
	{
		$output = '<br/>';
		$output .= '<hr color="#4B88E4" style="color:#4B88E4; margin-top:7px; margin-bottom:7px;"/>';
		if ($value) {
			$output .= '<span style="color:#0B55C4;">'.JText::_($value).'</span>';
		} else {
			$output .= '&nbsp;';
		}
		$output .= '<hr color="#CCCCCC" style="color:#CCCCCC; margin-top:7px; margin-bottom:7px;"/>';

		return $output;
	}
}
