﻿<?php

/*
*	eventDirections plugin
*	version 1.5.1 23/01/2009
*
*	Copyright Ewout Wierda © 2008/2009. All rights reserved. 
*	This program is free software: you can redistribute it and/or modify it under 
*	the terms of the GNU General Public License version 3 as published by the 
*	Free Software Foundation, see <http://www.gnu.org/licenses/>.
*	This program is distributed in the hope that it will be useful, but WITHOUT 
*	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*	or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more details.
*	Free for non-commercial use, payment for commercial use on request.
*	mail@joomlaloft.com
*	joomlaloft.com
*
*	nextEvent is a module to display details of the next upcoming event in EventList 
*	together with a countdown time. The countdown can optionally be offset to a 
*	deadline for bookings. The event details are strung together by four items of text, 
*	and include name, date, time and venue as well as the event and venue images, 
*	and links to the event and venue details pages are added. Many options are 
*	provided to customise layout, style and language. This Joomla extension is 
*	translation-ready.  nextEvent was written for EventList but can also be used 
*	with RedEvent.
*/



/* TODO 
add linked category
DONE replace if else statements by Ternary Operator variable = (condition) ? iftrue : iffalse ;
*/



/*** get the framework ***/

/* framework check */
defined( '_JEXEC' ) or die( 'Restricted access' );

/* get database */
$database =& JFactory::getDBO();

/* bco - get user access rights */
$user =& JFactory::getUser();
$aid  = $user->get('aid', 0);

/* get language */
$lang = & JFactory::getLanguage();
$lang->load('mod_nextevent');

/* get eventlist router */
require_once(JPATH_SITE.DS.'components'.DS.'com_eventlist'.DS.'helpers'.DS.'route.php');



/*** open customisable style wrapper ***/

/* check if custom styles have been set or set to standard */
$nE_blockid = $params->get( 'blockid', 'nexteventblock' );
$nE_blockclass = $params->get( 'blockclass', 'nexteventblock' );
$nE_blockstyle = $params->get( 'blockstyle', 'text-align:center;' );

/* create output */
$nE_output = '<div id="'.$nE_blockid.'" class="'.$nE_blockclass.'" style="'.$nE_blockstyle.'">';



/*** get input from the database ***/

/*check which component has been set as active or set to standard */
$nE_component = $params->get( 'component', 'eventlist' );

/* prepare active component for database query*/
if ($nE_component == 'eventlist') {
	$nE_events_table = '#__eventlist_events';
	$nE_venues_table = '#__eventlist_venues';
	$nE_categories_table = '#__eventlist_categories';
} else if ($nE_component == 'redevent') {
	$nE_events_table = '#__redevent_events';
	$nE_venues_table = '#__redevent_venues';
	$nE_categories_table = '#__redevent_categories';
}

/* prepare event restriction for database query */
$nE_eventid = $params->get( 'eventid' );
if ($nE_eventid != '') {
	$wherewhen = '';
	$nE_evnt_cond = ' AND (e.id=' . $nE_eventid . ')';
} else {
	$wherewhen = ' AND ( e.dates > CURRENT_DATE() OR ( e.dates = CURRENT_DATE() AND e.times > CURTIME() ) ) ';
	$nE_evnt_cond = '';
}

/* prepare category restriction for database query */
$nE_categoryids = $params->get( 'categoryids' );
if ($nE_eventid == '' && $nE_categoryids != '') {
	$nE_cat_ids = explode( ',', $nE_categoryids );
	JArrayHelper::toInteger( $nE_cat_ids );
	$nE_cat_cond = ' AND (e.catsid=' . implode( ' OR e.catsid=', $nE_cat_ids ) . ')';
} else {
/* bco - manage access rights */
/*	$nE_cat_cond = '';*/
	$nE_cat_cond = ' AND (e.catsid = c.id) AND (c.access <='.$aid.')';
}

/* prepare venue restriction for database query */
$nE_venueids = $params->get( 'venueids' );
if ($nE_eventid == '' && $nE_venueids != '') {
	$nE_ven_ids = explode( ',', $nE_venueids );
	JArrayHelper::toInteger( $nE_ven_ids );
	$nE_ven_cond = ' AND (e.locid=' . implode( ' OR e.locid=', $nE_ven_ids ) . ')';
} else {
	$nE_ven_cond = '';
}

/* make a database query - bco - honour access rights */
/* $query = 	"SELECT id,datimage,title,dates,times,locid,registra,datdescription,catsid */
/*			FROM ".$nE_events_table." AS e */
$query = 	"SELECT e.id,e.datimage,e.title,e.dates,e.times,e.locid,e.registra,e.datdescription,e.catsid 
			FROM ".$nE_events_table." AS e, ".$nE_categories_table." AS c 
			WHERE e.published ='1'
			 ".$wherewhen."
			 ".$nE_evnt_cond."
			 ".$nE_cat_cond."
			 ".$nE_ven_cond."
			ORDER BY dates,times ASC LIMIT 1 ";
$database->setQuery($query);
$event_details_array = $database->loadRow();



/*** create output for when there is no upcoming event ***/
if ( empty( $event_details_array[2] ) || empty( $event_details_array[3] ) ) {

	/* prepare text for if there is no upcoming event */
	$nE_l_noevent = ($nE_category != '') ? JText::_('NO CAT EVENT') : JText::_('NO EVENT');
	$nE_noevent = $params->get( 'noeventtext', $nE_l_noevent );

	$nE_output .= $nE_noevent;



/*** create output for the upcoming event ***/
} else {



	/*** prepare output ***/


	/** get the results from the database query **/
	$nE_id = $event_details_array[0];
	$nEimage = $event_details_array[1];
	$nE_image = ( !empty($nEimage) ) ? $nEimage : '';
	$nE_title = $event_details_array[2];
	$nE_date = $event_details_array[3];
	$nEtime = $event_details_array[4];
	$nE_time = ( !empty($nEtime) ) ? $nEtime : 0;
	$nEvenue = $event_details_array[5];
	$nE_venue = ( !empty($nEvenue) ) ? $nEvenue : 0;
	$nEbook = $event_details_array[6];
	$nE_book = ( !empty($nEbook) ) ? $nEbook : 0;
	$nEdescript = $event_details_array[7];
	$nE_descript = ( !empty($nEdescript) ) ? $nEdescript : '';
	$nE_cat = $event_details_array[8];


	/** venue database query **/
	$nEvenuename = '';
	$nEvenueimage = '';
	if ( !empty($nE_venue) ) {
		$query = 	"SELECT venue,locimage 
					FROM ".$nE_venues_table." 
					WHERE id='".$nE_venue."'";
		$database->setQuery($query);
		$venue_details_array = $database->loadRow();
		$nEvenuename = $venue_details_array[0];
		$nEvenueimage = $venue_details_array[1];
	}
	$nE_venue_name = ( !empty($nEvenuename ) ) ? $nEvenuename : '';
	$nE_venue_image = ( !empty($nEvenueimage ) ) ? $nEvenueimage : '';


	/** category database query **/
	$query = 	"SELECT catname,groupid 
				FROM ".$nE_categories_table." 
				WHERE id='".$nE_cat."'";
	$database->setQuery($query);
	$cat_details_array = $database->loadRow();
	$nE_category = $cat_details_array[0];


	/** calculate countdown **/

	// Inspired by countdown_de.php copyright (C) 2004, Juergen Boese ( www.jurbo.de - webmaster@jurbo.de ) 

	/* prepare date for calculations */
	if (strpos($nE_date, "-") !== 0) {
		$dateis = 1;
		list($y, $m, $d) = explode('-', $nE_date);
		$year = $y;
		$month = ltrim( $m, "0" );
		$day = ltrim( $d, "0" );
	} else {
		$dateis = 0;
	}

	/* prepare time for calculations */
	if (strpos($nE_time, ":") !== 0) {
		$timeis = 1;
		list($h, $min, $s) = explode(':', $nE_time);
		$hour = $h>0 ? ltrim( $h, "0" ) : '0';
		$minute = $min>0 ? ltrim( $min, "0" ) : '0';
		$second = '0';
	} else {
		$timeis = 0;
	}

	/* check if there is a date and a time for calculations */
	if ( $dateis == 1 ) {

		if ( $timeis == 1 ) {
			/* calculate seconds left until event date and time */
			$targettime = mktime($hour,$minute,0,$month,$day,$year);
			$presenttime = time();
			$secondsleft = $targettime - $presenttime;
		} else {
			$targettime = mktime(12,0,0,$month,$day,$year);
			$presenttime = time();
			$secondsleft = $targettime - $presenttime;
		}

		/* calculate time units left until event date and time */
		$weeks = floor($secondsleft/604800);
		$days = floor($secondsleft/86400);
		$hours = floor($secondsleft%86400/3600);
		$minutes = floor($secondsleft%86400%3600/60);
		$seconds = floor($secondsleft%86400%3600%60);

		/* calculate offset seconds left until deadline for bookings */
		$u_bookingoffset = $params->get( 'bookingoffset', 48 );
		$nE_offsetseconds = $u_bookingoffset * 60 * 60;
		$offsetseconds = $secondsleft - $nE_offsetseconds;

		/* calculate offset time units left until deadline for bookings */
		$bookweeks = floor($offsetseconds/604800);
		$bookdays = floor($offsetseconds/86400);
		$bookhours = floor($offsetseconds%86400/3600);
		$bookminutes = floor($offsetseconds%86400%3600/60);
		$bookseconds = floor($offsetseconds%86400%3600%60);

		/* prepare text to be inserted in countdown */
		$s_weektext = JText::_('WEEK TEXT');
		$s_weekstext = JText::_('WEEKS TEXT');
		$s_daytext = JText::_('DAY TEXT');
		$s_daystext = JText::_('DAYS TEXT');
		$s_hourtext = JText::_('HOUR TEXT');
		$s_hourstext = JText::_('HOURS TEXT');
		$s_minutetext = JText::_('MINUTE TEXT');
		$s_minutestext = JText::_('MINUTES TEXT');
		$s_secondtext = JText::_('SECOND TEXT');
		$s_secondstext = JText::_('SECONDS TEXT');

		$u_weektext = $params->get( 'weektext', $s_weektext );
		$u_weekstext = $params->get( 'weekstext', $s_weekstext );
		$u_daytext = $params->get( 'daytext', $s_daytext );
		$u_daystext = $params->get( 'daystext', $s_daystext );
		$u_hourtext = $params->get( 'hourtext', $s_hourtext );
		$u_hourstext = $params->get( 'hourstext', $s_hourstext );
		$u_minutetext = $params->get( 'minutetext', $s_minutetext );
		$u_minutestext = $params->get( 'minutestext', $s_minutestext );
		$u_secondtext = $params->get( 'secondtext', $s_secondtext );
		$u_secondstext = $params->get( 'secondstext', $s_secondstext );

		/* check time units to be displayed */
		$nE_timeunit = $params->get( 'timeunit', 3 );
		$nE_cutperiod = $params->get( 'cutperiod', 30 );
		$nE_cutseconds = $nE_cutperiod * 60 * 60 * 24;

		/* prepare countdown until event date and time */
		$nE_count = "";
		if ( $secondsleft > $nE_cutseconds ) {
			$nE_count = $weeks . ' ' . $u_weekstext;
		} else {
			if ( $nE_timeunit > 0 ) {
				if ( $days > 1 ) {
					$nE_count .= ' ' . $days . ' ' . $u_daystext;
				} else if ( $days <= 1 ) {
					$nE_count .= ' ' . $days . ' ' . $u_daytext;
				}
			}
			if ( $nE_timeunit > 1 ) {
				if ( $hours > 1 ) {
					$nE_count .= ' ' . $hours . ' ' . $u_hourstext;
				} else if ( $hours <= 1 ) {
					$nE_count .= ' ' . $hours . ' ' . $u_hourtext;
				}
			}
			if ( $nE_timeunit > 2 ) {
				if ( $minutes > 1 ) {
					$nE_count .= ' ' . $minutes . ' ' . $u_minutestext;
				} else if ( $minutes <= 1 ) {
					$nE_count .= ' ' . $minutes . ' ' . $u_minutetext;
				}
			}
			if ( $nE_timeunit > 3 ) {
				if ( $seconds > 1 ) {
					$nE_count .= ' ' . $seconds . ' ' . $u_secondstext;
				} else if ( $seconds <= 1 ) {
					$nE_count .= ' ' . $seconds . ' ' . $u_secondtext;
				}
			}
		}

		/* prepare countdown until offset booking deadline date and time */
		$nE_offset = "";
		if ( $offsetseconds > $nE_cutseconds ) {
			$nE_offset = $bookweeks . ' ' . $u_weekstext;
		} else {
			if ( $nE_timeunit > 0 ) {
				if ( $bookdays > 1 ) {
					$nE_offset .= ' ' . $bookdays . ' ' . $u_daystext;
				} else if ( $bookdays <= 1 ) {
					$nE_offset .= ' ' . $bookdays . ' ' . $u_daytext;
				}
			}
			if ( $nE_timeunit > 1 ) {
				if ( $bookhours > 1 ) {
					$nE_offset .= ' ' . $bookhours . ' ' . $u_hourstext;
				} else if ( $bookhours <= 1 ) {
					$nE_offset .= ' ' . $bookhours . ' ' . $u_hourtext;
				}
			}
			if ( $nE_timeunit > 2 ) {
				if ( $bookminutes > 1 ) {
					$nE_offset .= ' ' . $bookminutes . ' ' . $u_minutestext;
				} else if ( $bookminutes <= 1 ) {
					$nE_offset .= ' ' . $bookminutes . ' ' . $u_minutetext;
				}
			}
			if ( $nE_timeunit > 3 ) {
				if ( $bookseconds > 1 ) {
					$nE_offset .= ' ' . $bookseconds . ' ' . $u_secondstext;
				} else if ( $bookseconds <= 1 ) {
					$nE_offset .= ' ' . $bookseconds . ' ' . $u_secondtext;
				}
			}
		}

	} else {
		/* prepare output for when no date is available */
		$s_nodatetext = JText::_('NO DATE');
		$u_nodatetext = $params->get( 'nodatetext', $s_nodatetext );
		$nE_count = $u_nodatetext;
		$nE_offset = $u_nodatetext;
	}


	/** prepare countdown **/

	/* check if custom styles have been set or set to standard */
	$nE_countid = $params->get( 'countid', 'nexteventcount' );
	$nE_countclass = $params->get( 'countclass', 'nexteventcount' );
	$nE_countstyle = $params->get( 'countstyle', 'text-align:center;' );

	/* create output */
	$nE_countdown = '<div id="'.$nE_countid.'" class="'.$nE_countclass.'" style="'.$nE_countstyle.'">';
	$nE_countdown .= $nE_count;
	$nE_countdown .= '</div>';

	$nE_countoffset = '<div id="'.$nE_countid.'" class="'.$nE_countclass.'" style="'.$nE_countstyle.'">';
	$nE_countoffset .= $nE_offset;
	$nE_countoffset .= '</div>';


	/** prepare formatted date and time output **/

	/* prepare date for display */
	$nE_date_form = $params->get( 'date_form', '%d-%m-%Y' );
	$nE_cust_date_form = $params->get( 'cust_date_form', '' );
	$date_form = ($nE_cust_date_form != '') ? $nE_cust_date_form : $nE_date_form;
	$nE_form_date = ( empty($nE_date) ) ? '' : strftime( $date_form, strtotime( $nE_date ) );

	/* prepare time for display */
	//$nE_trimmedtime = rtrim(rtrim($nE_time,'0'),':');
	$nE_time_form = $params->get( 'time_form', '%H:%M' );
	$nE_cust_time_form = $params->get( 'cust_time_form', '' );
	$time_form = ($nE_cust_time_form != '') ? $nE_cust_time_form : $nE_time_form;
	$nE_form_time = ( empty($nE_time) ) ? '' : strftime( $time_form, strtotime( $nE_time ) );



	/*** create output - upper part ***/


	/** countdown **/

	/* check if countdown should be shown */
	$nE_uselayout = $params->get( 'uselayout', 1 );
	$nE_u_layout = $params->get( 'u_layout', 3 );
	$nE_layout = ($nE_eventid != '') ? 3 : $nE_u_layout;
	$nE_placecount = $params->get( 'placecount', 2 );
	$countextraspace = $params->get( 'countextraspace', 0 );
	if ( ( $nE_uselayout == 0 && $nE_placecount == 1 ) || ( $nE_uselayout == 1 && $nE_layout == 1 ) ) {

		/* create output */
		$nE_output .= $nE_countdown;
		if ( $nE_uselayout == 0 && $countextraspace == 1 ) {
			$nE_output .= '<br/>';
		}

	}


	/** top text **/

	/* check if text should be shown */
	$nE_showtop = $params->get( 'showtop', 1 );
	$extraspace = $params->get( 'extraspace', 0 );
	if ( ( $nE_uselayout == 0 && $nE_showtop == 1 ) || ( $nE_uselayout == 1 && ( $nE_layout == 1 || $nE_layout == 2 || $nE_layout == 4 ) ) ) {

		/* check if custom text has been set or set to standard */
		if ( $nE_uselayout == 1 ) {
			if ( $nE_layout == 1 ) {
				$nE_l_toptext = JText::_('TOP TEXT 1');
			} else if ( $nE_layout == 2 ) {
				$nE_l_toptext = JText::_('TOP TEXT 2');
			} else if ( $nE_layout == 4 ) {
				$nE_l_toptext = JText::_('TOP TEXT 4');
			}
		} else if ( $nE_uselayout == 0 ) {
			$nE_l_toptext = JText::_('FILL IN TOP TEXT');
		}
		$nE_toptext = $params->get( 'toptext', $nE_l_toptext );

		/* check if custom styles have been set or set to standard */
		$nE_topid = $params->get( 'topid', 'nexteventtop' );
		$nE_topclass = $params->get( 'topclass', 'nexteventtop' );
		$nE_topstyle = $params->get( 'topstyle', 'text-align:center;' );
		$nE_toplinkstyle = $params->get( 'toplinkstyle', '' );

		/*prepare link*/
		$linktop = $params->get( 'linktop', 1 );
		//$topurl = JRoute::_( 'index.php?option=com_eventlist&view=details&id=' . $nE_id );
		$topurl = EventListHelperRoute::getRoute( $nE_id, 'details' );
		$toplinkstyle = 'style="'.$nE_toplinkstyle.'"';
		$toplink = JHTML::link( $topurl, $nE_toptext, $toplinkstyle );

		/* create output */
		$nE_output .= '<div id="'.$nE_topid.'" class="'.$nE_topclass.'" style="'.$nE_topstyle.'">';
		$nE_output .= ($nE_uselayout == 0 && $linktop == 1) ? $toplink : $nE_toptext ;
		$topextraspace = $params->get( 'topextraspace', 0 );
		if ( $nE_uselayout == 0 && $topextraspace == 1 ) {
			$nE_output .= '<br/>&nbsp;';
		}
		$nE_output .= '</div>';

	}


	/** countdown **/

	/* check if countdown should be shown */
	if ( ( $nE_uselayout == 0 && $nE_placecount == 2 ) || ( $nE_uselayout == 1 && $nE_layout == 2 ) ) {

		/* create output */
		$nE_output .= $nE_countdown;
		if ( ( $nE_uselayout == 0 && $countextraspace == 1 ) || ( $nE_uselayout == 1 && $nE_layout == 2 && $extraspace == 1 ) ) {
			$nE_output .= '<br/>';
		}

	}


	/** pre text **/

	/* check if text should be shown */
	$nE_showpre = $params->get( 'showpre', 1 );
	if ( ( $nE_uselayout == 0 && $nE_showpre == 1 ) || ( $nE_uselayout == 1 && $nE_layout == 2 ) ) {

		/* check if custom text has been set or set to standard */
		if ( $nE_uselayout == 1 && $nE_layout == 2 ) {
			$nE_l_pretext = ($nE_book == 1) ? JText::_('PRE TEXT 2B') : JText::_('PRE TEXT 2A') ;
		} else if ( $nE_uselayout == 0 ) {
			$nE_l_pretext = JText::_('FILL IN PRE TEXT');
		}
		$nE_pretext = $params->get( 'pretext', $nE_l_pretext );

		/* check if custom styles have been set or set to standard */
		$nE_preid = $params->get( 'preid', 'nexteventpre' );
		$nE_preclass = $params->get( 'preclass', 'nexteventpre' );
		$nE_prestyle = $params->get( 'prestyle', 'text-align:center;' );
		$nE_prelinkstyle = $params->get( 'prelinkstyle', '' );

		/*prepare link*/
		$linkpre = $params->get( 'linkpre', 1 );
		//$preurl = JRoute::_( 'index.php?option=com_eventlist&view=details&id=' . $nE_id );
		$preurl = EventListHelperRoute::getRoute( $nE_id, 'details' );
		$prelinkstyle = 'style="'.$nE_prelinkstyle.'"';
		$prelink = JHTML::link( $preurl, $nE_pretext, $prelinkstyle );

		/* create output */
		$nE_output .= '<div id="'.$nE_preid.'" class="'.$nE_preclass.'" style="'.$nE_prestyle.'">';
		$nE_output .= ( ( $nE_uselayout == 0 && $linkpre == 1 ) || ( $nE_uselayout == 1 && $nE_layout == 2 ) ) ? $prelink : $nE_pretext ;
		$preextraspace = $params->get( 'preextraspace', 0 );
		if ( $nE_uselayout == 0 && $preextraspace == 1 ) {
			$nE_output .= '<br/>&nbsp;';
		}
		$nE_output .= '</div>';
	
	}



	/*** create output - middle part ***/


	/** preparing details **/

	/*get params*/
	$nE_linebreak = $params->get( 'linebreak', 1 );
	$nE_insertat = $params->get( 'insertat', 1 );

	/* check if block should be shown */
	$nE_showimagecheck = (empty($nE_image)) ? 0 : 1 ;
	$nE_showtitlecheck = (empty($nE_title)) ? 0 : 1 ;
	$nE_showcatcheck = (empty($nE_category)) ? 0 : 1 ;
	$nE_showdatecheck = ($nE_form_date == '') ? 0 : 1 ;
	$nE_showtimecheck = ($nE_form_time == '') ? 0 : 1 ;
	$nE_showdescriptioncheck = (empty($nE_descript)) ? 0 : 1 ;
	$nE_showvenuecheck = (empty($nE_venue_name)) ? 0 : 1 ;
	$nE_showvimagecheck = (empty($nE_venue_image)) ? 0 : 1 ;
	$nE_showimage = $params->get( 'showimage', 1 );
	$nE_showtitle = $params->get( 'showtitle', 1 );
	$nE_showcategory = $params->get( 'showcategory', 0 );
	$nE_showdatetime = $params->get( 'showdatetime', 1 );
	$nE_showdescription = $params->get( 'showdescription', 0 );
	$nE_showvenue = $params->get( 'showvenue', 1 );
	$nE_showvimage = $params->get( 'showvimage', 1 );
	if ( ( $nE_showimagecheck == 1 || $nE_showtitlecheck == 1 || $nE_showcatcheck == 1 || $nE_showdatecheck == 1 || $nE_showtimecheck == 1 || $nE_showdescriptioncheck == 1 || $nE_showvimagecheck == 1 || $nE_showvenuecheck == 1 ) && ( ( $nE_uselayout == 0 && ( $nE_showimage == 1 || $nE_showtitle == 1 || $nE_showcategory == 1 || $nE_showdatetime == 1 || $nE_showdescription == 1 || $nE_showvimage == 1 || $nE_showvenue == 1 ) ) || ( $nE_uselayout == 1 ) ) ) {

		/* check if custom styles have been set or set to standard */
		$nE_detailsid = $params->get( 'detailsid', 'nexteventdetails' );
		$nE_detailsclass = $params->get( 'detailsclass', 'nexteventdetails' );
		$nE_detailsstyle = $params->get( 'detailsstyle', 'text-align:center;' );

		/* surrounding div output */

		$nE_output .= '<div id="'.$nE_detailsid.'" class="'.$nE_detailsclass.'" style="'.$nE_detailsstyle.'">';

	}


	/** event image **/

	/* check if text should be shown */
	$nE_images = $params->get( 'images', 1 );
	if ( $nE_showimagecheck == 1 && ( ( $nE_uselayout == 0 && $nE_showimage == 1 ) || ( $nE_uselayout == 1 && ( $nE_images == 1 || $nE_images == 3 ) ) ) ) {

		/*prepare attributes */
		if ( $nE_uselayout == 1 ) {
				$imageheight = '';
				$imagewidth = ' width:75%;';
				$imagealign = ' text-align:center;';
		} else {
			$nE_imageheight = $params->get( 'imageheight', '' );
			$imageheight = ($nE_imageheight != '') ? ' height:'.$nE_imageheight.';' : '' ;
			$nE_imagewidth = $params->get( 'imagewidth', '' );
			$imagewidth = ($nE_imagewidth != '') ? ' width:'.$nE_imagewidth.';' : '' ;
			$nE_imagealign = $params->get( 'imagealign', 'center' );
			$imagealign = ' text-align:'.$nE_imagealign.';';
		}

		/* prepare output */
		if ($nE_image != '') {
			$imageurl = JURI::base().'images'.DS.'eventlist'.DS.'events'.DS.$nE_image;
			$imagealt = $nE_title . ' image' ;
		} else {
			$imageurl = JURI::base().'components'.DS.'com_eventlist'.DS.'assets'.DS.'images'.DS.'noimage.png';
			$imagealt = $nE_title . ' image not available' ;
		}
		$imageatt = 'style="border:none;'.$imagealign.$imagewidth.$imageheight.'"';
		$image = JHTML::image( $imageurl, $imagealt, $imageatt );

		/*prepare link*/
		$linkimage = $params->get( 'linkvimage', 1 );
		//$eventurl = JRoute::_( 'index.php?option=com_eventlist&view=details&id=' . $nE_id );
		$eventurl = EventListHelperRoute::getRoute( $nE_id, 'details' );
		$imagelink = JHTML::link( $eventurl, $image );

		/* create output */
		$nE_output .= ( ( $nE_uselayout == 0 && $linkimage == 1 ) || $nE_uselayout == 1 ) ? $imagelink : $image ;
		$nE_output .= '<br/>';

	}


	/** event title **/

	/* check if text should be shown */
	if ( $nE_showtitlecheck == 1 && ( ( $nE_uselayout == 0 && $nE_showtitle == 1 ) || $nE_uselayout == 1 ) ) {

		/* check if custom styles have been set or set to standard */
		$nE_titleid = $params->get( 'titleid', 'nexteventtitle' );
		$nE_titleclass = $params->get( 'titleclass', 'nexteventtitle' );
		$nE_titlestyle = $params->get( 'titlestyle', 'text-align:center; font-weight:bold; font-size: larger;' );
		$nE_titlelinkstyle = $params->get( 'titlelinkstyle', '' );

		/*prepare link*/
		$linktitle = $params->get( 'linktitle', 0 );
		//$titleurl = JRoute::_( 'index.php?option=com_eventlist&view=details&id=' . $nE_id );
		$titleurl = EventListHelperRoute::getRoute( $nE_id, 'details' );
		$titlelinkstyle = 'style="'.$nE_titlelinkstyle.'"';
		$titlelink = JHTML::link( $titleurl, $nE_title, $titlelinkstyle );

		/* create output */
		$nE_output .= '<span id="'.$nE_titleid.'" class="'.$nE_titleclass.'" style="'.$nE_titlestyle.'">';
		$nE_output .= ($nE_uselayout == 0 && $linktitle == 1) ? $titlelink : $nE_title ;
		if ( $nE_linebreak == 1 ) {
			$nE_output .= '<br/>';
		}
		$nE_output .= '</span>';

	}


	/** event description **/

	/* check if text should be shown */
	$nE_description = $params->get( 'description', 0 );
	if ( $nE_showdescriptioncheck == 1 && ( ( $nE_uselayout == 0 && $nE_showdescription == 1 ) || ( $nE_uselayout == 1 && ( $nE_eventid != '' || $nE_description > 0 ) ) ) ) {

		/* check if custom styles have been set or set to standard */
		$nE_descriptionid = $params->get( 'descriptid', 'nexteventdescription' );
		$nE_descriptionclass = $params->get( 'descriptclass', 'nexteventdescription' );
		$nE_descriptionstyle = $params->get( 'descriptstyle', 'margin-top:2px; padding-top:3px; padding-bottom:3px; border-top:1px dotted gray; border-bottom:1px dotted gray; text-align:justify; font-size:smaller;' );
		$nE_descriptionlinkstyle = $params->get( 'descriptionlinkstyle', '' );

		/*prepare link*/
		$nE_readmoretext = $params->get( 'readmoretext', ' ...' );
		$linkdescription = $params->get( 'linkdescription', 0 ) ;
		//$descriptionurl = JRoute::_( 'index.php?option=com_eventlist&view=details&id=' . $nE_id );
		$descriptionurl = EventListHelperRoute::getRoute( $nE_id, 'details' );
		$descriptionlinkstyle = 'style="'.$nE_descriptionlinkstyle.'"';
		$descriptionlink = JHTML::link( $descriptionurl, $nE_readmoretext, $descriptionlinkstyle );

		/* prepare description */
		$descrlength = strlen($nE_descript) ;
		if ( $nE_uselayout == 1 ) {
			if ( ( $nE_description == 1 || $nE_eventid != '' ) && $descrlength > 75 ) {
				$description = substr($nE_descript,0,75) ;
			} else if ( $nE_description == 2 && $descrlength > 250 ) {
				$description = substr($nE_descript,0,250) ;
			} else {
				$description = $nE_descript;
			}
		} else {
			$nE_maxdescrlength = $params->get( 'maxdescrlength', 0 ) ;
			$description = ( $nE_maxdescrlength != 0 && $descrlength > $nE_maxdescrlength ) ? substr($nE_descript,0,$nE_maxdescrlength) : $nE_descript ;
		}

		/* create output */
		$nE_output .= '<p id="'.$nE_descriptionid.'" class="'.$nE_descriptionclass.'" style="'.$nE_descriptionstyle.'">';
		$nE_output .= $description;
		if ( $nE_uselayout == 0 && $linkdescription == 1 ) {
			$nE_output .= $descriptionlink;
		} else if ( $nE_uselayout == 0 && $linkdescription == 0 ) {
			$nE_output .= $nE_readmoretext;
		} else if ( $nE_uselayout == 1 && ( ( ( $nE_description == 1 || $nE_eventid != '' ) && $descrlength > 75 ) || ( $nE_description == 2 && $descrlength > 250 ) ) ) {
			$nE_output .= ' ...';
		}
		$nE_output .= '</p>';
	
	}


	/** event category **/

	/* check if text should be shown */
	if ( ( $nE_showcatcheck == 1 ) && ( ( $nE_uselayout == 0 && $nE_showcategory == 1 ) || $nE_eventid != '' ) ) {

		/* check if custom styles have been set or set to standard */
		$nE_categoryid = $params->get( 'categoryid', 'nexteventcategory' );
		$nE_categoryclass = $params->get( 'categoryclass', 'nexteventcategory' );
		$nE_categorystyle = $params->get( 'categorystyle', 'text-align:center;' );
		$nE_categorylinkstyle = $params->get( 'categorylinkstyle', '' );

		/*prepare link*/
		$linkcategory = $params->get( 'linkcategory', 0 );
		//$categoryurl = JRoute::_( 'index.php?option=com_eventlist&view=categoryevents&id=' . $nE_cat );
		$categoryurl = EventListHelperRoute::getRoute( $nE_cat, 'categoryevents' );
		$categorylinkstyle = 'style="'.$nE_categorylinkstyle.'"';
		$categorylink = JHTML::link( $categoryurl, $nE_category, $categorylinkstyle );

		/* create output */
		$nE_output .= '<span id="'.$nE_categoryid.'" class="'.$nE_categoryclass.'" style="'.$nE_categorystyle.'">';
		if ( $nE_insertat == 1 ) {
			$insertat_a = JText::_('A').' ';
			$nE_insertat_a = $params->get( 'insertat_a', $insertat_a );
			$nE_output .= $nE_insertat_a;
			$nE_output .= $nE_cattext_a;
		// check if description is shown
		} else if ( $nE_linebreak == 0 && ( $nE_showdescriptioncheck == 1 && ( ( $nE_uselayout == 0 && $nE_showdescription == 1 ) || ( $nE_uselayout == 1 && ( $nE_eventid != '' || $nE_description > 0 ) ) ) ) ) {
		$nE_output .= '';
		} else if ( $nE_linebreak == 0 ) {
			$nE_output .= ', ';
		}
		$nE_output .= ( $nE_uselayout == 0 && $linkcategory == 1 ) ? $categorylink : $nE_category ;
		if ( $nE_insertat == 1 ) {
			$insertat_event = ' '.JText::_('EVENT');
			$nE_insertat_event = $params->get( 'insertat_event', $insertat_event );
			$nE_output .= $nE_insertat_event;
			$nE_output .= $nE_cattext_event;
		}
		if ( $nE_linebreak == 1 ) {
			$nE_output .= '<br/>';
		}
		$nE_output .= '</span>';

	}


	/** event date & time **/

	/* check if text should be shown */
	if ( ( $nE_showdatecheck == 1 || $nE_showtimecheck == 1 ) && ( ( $nE_uselayout == 0 && $nE_showdatetime == 1 ) || $nE_uselayout == 1 ) ) {

		/* check if custom styles have been set or set to standard */
		$nE_datetimeid = $params->get( 'datetimeid', 'nexteventdatetime' );
		$nE_datetimeclass = $params->get( 'datetimeclass', 'nexteventdatetime' );
		$nE_datetimestyle = $params->get( 'datetimestyle', 'text-align:center;' );

		/* create output */
		$nE_output .= '<span id="'.$nE_datetimeid.'" class="'.$nE_datetimeclass.'" style="'.$nE_datetimestyle.'">';
		if ( $nE_showdatecheck == 1 ) {
			if ( $nE_insertat == 1 ) {
				$insertat_on = ' '.JText::_('ON').' ';
				$nE_insertat_on = $params->get( 'insertat_on', $insertat_on );
				$nE_output .= $nE_insertat_on;
			// check if description or category is shown
			} else if ( $nE_linebreak == 0 && ( $nE_showdescriptioncheck == 1 && ( ( $nE_uselayout == 0 && $nE_showdescription == 1 ) || ( $nE_uselayout == 1 && ( $nE_eventid != '' || $nE_description > 0 ) ) ) ) || ( ( $nE_showcatcheck == 1 ) && ( ( $nE_uselayout == 0 && $nE_showcategory == 1 ) || $nE_eventid != '' ) ) ) {
				$nE_output .= '';
			} else if ( $nE_linebreak == 0 ) {
				$nE_output .= ', ';
			}
		$nE_output .= $nE_form_date;
		}
		if ( $nE_showtimecheck == 1 ) {
			if ( $nE_insertat == 1 ) {
				$insertat_at = ' '.JText::_('AT').' ';
				$nE_insertat_at = $params->get( 'insertat_at', $insertat_at );
				$nE_output .= $nE_insertat_at;
			} else if ( $nE_linebreak == 0 ) {
				$nE_output .= ', ';
			}
			$nE_output .= $nE_form_time;
		}
		if ( $nE_linebreak == 1 ) {
			$nE_output .= '<br/>';
		}
		$nE_output .= '</span>';

	}


	/** venue name **/

	/* check if text should be shown */
	if ( $nE_showvenuecheck == 1 && ( ( $nE_uselayout == 0 && $nE_showvenue == 1 ) || $nE_uselayout == 1 ) ) {

		/* check if custom styles have been set or set to standard */
		$nE_venueid = $params->get( 'venueid', 'nexteventvenue' );
		$nE_venueclass = $params->get( 'venueclass', 'nexteventvenue' );
		$nE_venuestyle = $params->get( 'venuestyle', 'text-align:center;' );
		$nE_venuelinkstyle = $params->get( 'venuelinkstyle', '' );

		/*prepare link*/
		$linkvenue = $params->get( 'linkvenue', 0 );
		//$venueurl = JRoute::_( 'index.php?option=com_eventlist&view=venueevents&id=' . $nE_venue );
		$venueurl = EventListHelperRoute::getRoute( $nE_venue, 'venueevents' );
		$venuelinkstyle = 'style="'.$nE_venuelinkstyle.'"';
		$venuelink = JHTML::link( $venueurl, $nE_venue_name, $venuelinkstyle );

		/* create output */
		$nE_output .= '<span id="'.$nE_venueid.'" class="'.$nE_venueclass.'" style="'.$nE_venuestyle.'">';
		if ( $nE_insertat == 1 ) {
			$insertat_at = ' '.JText::_('AT').' ';
			$nE_insertat_at = $params->get( 'insertat_at', $insertat_at );
			$nE_output .= $nE_insertat_at;
		} else if ( $nE_linebreak == 0 ) {
			$nE_output .= ', ';
		}
		$nE_output .= ($nE_uselayout == 0 && $linkvenue == 1) ? $venuelink : $nE_venue_name ;
		$nE_output .= '</span>';

	}


	/** venue image **/

	/* check if text should be shown */
	if ( $nE_showvimagecheck == 1 && ( ( $nE_uselayout == 0 && $nE_showvimage == 1 ) || ( $nE_uselayout == 1 && ( $nE_images == 2 || $nE_images == 3 ) ) ) ) {

		/*prepare attributes */
		if ( $nE_uselayout == 1 ) {
				$vimageheight = '';
				$vimagewidth = ' width:75%;';
				$vimagealign = ' text-align:center;';
		} else {
			$nE_vimageheight = $params->get( 'vimageheight', '' );
			$vimageheight = ($nE_vimageheight != '') ? ' height:'.$nE_vimageheight.';' : '' ;
			$nE_vimagewidth = $params->get( 'vimagewidth', '' );
			$vimagewidth = ($nE_vimagewidth != '') ? ' width:'.$nE_vimagewidth.';' : '' ;
			$nE_vimagealign = $params->get( 'vimagealign', 'center' );
			$vimagealign = ' text-align:'.$nE_vimagealign.';';
		}

		/* prepare output */
		if ($nE_venue_image != '') {
			$vimageurl = JURI::base().'images'.DS.'eventlist'.DS.'venues'.DS.$nE_venue_image;
			$vimagealt = $nE_venue_name . ' image' ;
		} else {
			$vimageurl = JURI::base().'components'.DS.'com_eventlist'.DS.'assets'.DS.'images'.DS.'noimage.png';
			$vimagealt = $nE_venue_name . ' image not available' ;
		}
		$vimageatt = 'style="border:none;'.$vimagealign.$vimagewidth.$vimageheight.'"';
		$venueimage = JHTML::image( $vimageurl, $vimagealt, $vimageatt );

		/*prepare link*/
		$linkvimage = $params->get( 'linkvimage', 1 );
		//$venueurl = JRoute::_( 'index.php?option=com_eventlist&view=venueevents&id=' . $nE_venue );
		$venueurl = EventListHelperRoute::getRoute( $nE_venue, 'venueevents' );
		$vimagelink = JHTML::link( $venueurl, $venueimage );

		/* create output */
		$nE_output .= '<br/>';
		$nE_output .= ( ( $nE_uselayout == 0 && $linkvimage == 1 ) || $nE_uselayout == 1 ) ? $vimagelink : $venueimage ;
		$nE_output .= '<br/>';

	}


	/** closing middle part **/

	/* check if text should be shown */
	if ( ( $nE_showimagecheck == 1 || $nE_showtitlecheck == 1 || $nE_showdatecheck == 1 || $nE_showtimecheck == 1 || $nE_showdescriptioncheck == 1 || $nE_showvimagecheck == 1 || $nE_showvenuecheck == 1 ) && ( ( $nE_uselayout == 0 && ( $nE_showimage == 1 || $nE_showtitle == 1 || $nE_showdatetime == 1 || $nE_showdescription == 1 || $nE_showvimage == 1 || $nE_showvenue == 1 ) ) || ( $nE_uselayout == 1 ) ) ) {

		/* surrounding div output */
		$detailsextraspace = $params->get( 'detailsextraspace', 0 );
		if ( ( $nE_uselayout == 0 && $detailsextraspace == 1 ) || ( $nE_uselayout == 1 && ( $nE_layout == 3 || $nE_layout == 4 ) && $extraspace == 1 ) ) {
			$nE_output .= '<br/>&nbsp;';
		}
		$nE_output .= '</div>';
		
	}



	/*** create output - lower part ***/


	/** post text **/

	/* check if text should be shown */
	$nE_showpost = $params->get( 'showpost', 1 );
	if ( ( $nE_uselayout == 0 && $nE_showpost == 1 ) || ( $nE_uselayout == 1 && ( $nE_layout == 3 || $nE_layout == 4 ) ) ) {

		/* check if custom text has been set or set to standard */
		if ( $nE_uselayout == 1 ) {
			if ( $nE_layout == 3 ) {
				$nE_l_posttext = JText::_('POST TEXT 3');
			} else if ( $nE_layout == 4 ) {
				$nE_l_posttext = JText::_('POST TEXT 4');
			}
		} else if ( $nE_uselayout == 0 ) {
			$nE_l_posttext = JText::_('FILL IN POST TEXT');
		}
		$nE_posttext = $params->get( 'posttext', $nE_l_posttext );

		/* check if custom styles have been set or set to standard */
		$nE_postid = $params->get( 'postid', 'nexteventpost' );
		$nE_postclass = $params->get( 'postclass', 'nexteventpost' );
		$nE_poststyle = $params->get( 'poststyle', 'text-align:center;' );
		$nE_postlinkstyle = $params->get( 'postlinkstyle', '' );

		/*prepare link*/
		$linkpost = $params->get( 'linkpost', 1 );
		//$posturl = JRoute::_( 'index.php?option=com_eventlist&view=details&id=' . $nE_id );
		$posturl = EventListHelperRoute::getRoute( $nE_id, 'details' );
		$postlinkstyle = 'style="'.$nE_postlinkstyle.'"';
		$postlink = JHTML::link( $posturl, $nE_posttext, $postlinkstyle );

		/* create output */
		$nE_output .= '<div id="'.$nE_postid.'" class="'.$nE_postclass.'" style="'.$nE_poststyle.'">';
		$nE_output .= ($nE_uselayout == 0 && $linkpost == 1) ? $postlink : $nE_posttext ;
		$postextraspace = $params->get( 'postextraspace', 0 );
		if ( $nE_uselayout == 0 && $postextraspace == 1 ) {
			$nE_output .= '<br/>&nbsp;';
		}
		$nE_output .= '</div>';

	}


	/** countdown **/

	/* check if countdown should be shown */
	if ( ( $nE_uselayout == 0 && $nE_placecount == 3 ) || ( $nE_uselayout == 1 && ( $nE_layout == 3 || $nE_layout == 4 ) ) ) {
		$nE_showoffsetbooking = $params->get( 'showoffsetbooking', 0 );
		if ( ( $nE_uselayout == 0 && $nE_showoffsetbooking == 1 ) || ( $nE_uselayout == 1 && $nE_layout == 4 ) ) {

			/* create output */
			$nE_output .= $nE_countoffset;
		} else {
			$nE_output .= $nE_countdown;
		}
		$countextraspace = $params->get( 'countextraspace', 0 );
		if ( ( $nE_uselayout == 0 && $countextraspace == 1 ) || ( $nE_uselayout == 1 && $nE_layout == 3 && $extraspace == 1 ) ) {
			$nE_output .= '<br/>&nbsp;';
		}
	}


	/** bottom text **/

	/* check if text should be shown */
	$nE_showbottom = $params->get( 'showbottom', 1 );
	if ( ( $nE_uselayout == 0 && $nE_showbottom == 1 ) || ( $nE_uselayout == 1 && ( $nE_layout == 1 || $nE_layout == 3 || $nE_layout == 4 ) ) ) {

		/* check if custom text has been set or set to standard */
		if ( $nE_uselayout == 1 ) {
			if ( $nE_layout == 1 ) {
				$nE_l_bottomtext = ($nE_book == 1) ? JText::_('BOTTOM TEXT 1 B') : JText::_('BOTTOM TEXT 1 A') ;
			} else if ( $nE_layout == 3 ) {
				$nE_l_bottomtext = ($nE_book == 1) ? JText::_('BOTTOM TEXT 3 B') : JText::_('BOTTOM TEXT 3 A') ;
			} else if ( $nE_layout == 4 ) {
				$nE_l_bottomtext = JText::_('BOTTOM TEXT 4');
			}
		} else if ( $nE_uselayout == 0 ) {
			$nE_l_bottomtext = JText::_('FILL IN BOTTOM TEXT');
		}
		$nE_bottomtext = $params->get( 'bottomtext', $nE_l_bottomtext );

		/* check if custom styles have been set or set to standard */
		$nE_bottomid = $params->get( 'bottomid', 'nexteventbottom' );
		$nE_bottomclass = $params->get( 'bottomclass', 'nexteventbottom' );
		$nE_bottomstyle = $params->get( 'bottomstyle', 'text-align:center;' );
		$nE_bottomlinkstyle = $params->get( 'bottomlinkstyle', '' );

		/*prepare link*/
		$linkbottom = $params->get( 'linkbottom', 1 );
		//$bottomurl = JRoute::_( 'index.php?option=com_eventlist&view=details&id=' . $nE_id );
		$bottomurl = EventListHelperRoute::getRoute( $nE_id, 'details' );
		$bottomlinkstyle = 'style="'.$nE_bottomlinkstyle.'"';
		$bottomlink = JHTML::link( $bottomurl, $nE_bottomtext, $bottomlinkstyle );

		/* create output */
		$nE_output .= '<div id="'.$nE_bottomid.'" class="'.$nE_bottomclass.'" style="'.$nE_bottomstyle.'">';
		$nE_output .= ( ( $nE_uselayout == 0 && $linkbottom == 1 ) || ( $nE_uselayout == 1 && ( $nE_layout == 1 || $nE_layout == 3 || $nE_layout == 4 ) ) ) ? $bottomlink : $nE_bottomtext ;
		$bottomextraspace = $params->get( 'bottomextraspace', 0 );
		if ( $nE_uselayout == 0 && $bottomextraspace == 1 ) {
			$nE_output .= '<br/>&nbsp;';
		}
		$nE_output .= '</div>';
	}


}


	/** bottom text **/

	/* check if text should be shown */
	$nE_hidedev = $params->get( 'hidedev', 0 );
	if ( $nE_hidedev == 0 ) {
		$nE_output .= '<div style="font-size:8px; text-align:right;"><i>nextEvent</i> by <a href="http://www.joomlaloft.com" target="_blank">JoomlaLoft</a></div>';
	}


/*** close customisable style wrapper ***/

/* create output */
$nE_output .= '</div>';



/*** output ***/

echo $nE_output;



?>
